.intel_syntax noprefix
.altmacro

BLACK_BRUSH = 4

CS_BYTEALIGNWINDOW = 0x2000

IDI_APPLICATION = 32512
IDC_ARROW = 32512

PM_REMOVE = 1

SM_CXSCREEN = 0
SM_CYSCREEN = 1

SW_SHOWNORMAL = 1

WS_EX_OVERLAPPEDWINDOW = 0x300

WM_CLOSE   = 0x10
WM_DESTROY = 0x2
WM_PAINT   = 0xf
WM_QUIT    = 0x12
WM_COMMAND = 0x111
WM_TIMER   = 0x113

WS_OVERLAPPED       = 0
WS_MAXIMIZEBOX      = 0x10000
WS_MINIMIZEBOX      = 0x20000
WS_THICKFRAME       = 0x40000
WS_SYSMENU          = 0x80000
WS_CAPTION          = 0xC00000

WS_OVERLAPPEDWINDOW = WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX|WS_MAXIMIZEBOX

GetModuleHandle   = _GetModuleHandleA@4
GetStockObject    = _GetStockObject@4
LoadIcon          = _LoadIconA@8
LoadCursor        = _LoadCursorA@8
GetSystemMetrics  = _GetSystemMetrics@4
RegisterClassEx   = _RegisterClassExA@4
CreateWindowEx    = _CreateWindowExA@48
ShowWindow        = _ShowWindow@8
UpdateWindow      = _UpdateWindow@4
PeekMessage       = _PeekMessageA@20
GetMessage        = _GetMessageA@16
TranslateMessage  = _TranslateMessage@4
DispatchMessage   = _DispatchMessageA@4
InvalidateRgn     = _InvalidateRgn@12
ExitProcess       = _ExitProcess@4
BeginPaint        = _BeginPaint@8
EndPaint          = _EndPaint@8
GetClientRect     = _GetClientRect@8
CreateSolidBrush  = _CreateSolidBrush@4
SelectObject      = _SelectObject@8
Polygon           = _Polygon@12
DeleteObject      = _DeleteObject@4
DestroyWindow     = _DestroyWindow@4
PostQuitMessage   = _PostQuitMessage@4
DefWindowProc     = _DefWindowProcA@16
SetTimer          = _SetTimer@16
Sleep             = _Sleep@4

.macro MSG pre:req
  .bss
  .align 8
  \pre:
    \pre&.hwnd:     .int 0
    \pre&.message:  .int 0
    \pre&.wParam:   .int 0
    \pre&.lParam:   .int 0
    \pre&.time:     .int 0
    \pre&.pt.x:     .int 0
    \pre&.pt.y:     .int 0
  .text
.endm

.macro PAINTSTRUCT pre:req
  .bss
  .align 8
  \pre:
    \pre&.hdc:            .int 0
    \pre&.fErase:         .int 0
    \pre&.rcPaint.left:   .int 0
    \pre&.rcPaint.top:    .int 0
    \pre&.rcPaint.right:  .int 0
    \pre&.rcPaint.bottom: .int 0
    \pre&.fRestore:       .int 0
    \pre&.fIncUpdate:     .int 0
    \pre&.rgbReserved:    .fill 32
  .text
.endm

.macro POINT pre:req
  .bss
  .align 8
  \pre:
    \pre&.x: .int 0
    \pre&.y: .int 0
  .text
.endm

.macro RECT pre:req
  .bss
  .align 8
  \pre:
    \pre&.left:   .int 0
    \pre&.top:    .int 0
    \pre&.right:  .int 0
    \pre&.bottom: .int 0
  .text
.endm

.macro WNDCLASSEX pre:req
  .bss
  .align 8
  \pre:
    \pre&.cbSize:         .int 0
    \pre&.style:          .int 0
    \pre&.lpfnWndProc:    .int 0
    \pre&.cbClsExtra:     .int 0
    \pre&.cbWndExtra:     .int 0
    \pre&.hInstance:      .int 0
    \pre&.hIcon:          .int 0
    \pre&.hCursor:        .int 0
    \pre&.hbrBackground:  .int 0
    \pre&.lpszMenuName:   .int 0
    \pre&.lpszClassName:  .int 0
    \pre&.hIconSm:        .int 0
  .text
.endm
